<div id="pcpc2-section" class="section-profile">
    <div class="row">
         <div class="topleft duk-icon"><img onclick="removeSection('pcpc2-section')" src="/gui/img/x.png"></div>
         <div class="column" style="flex:40%;padding:15px;text-align: left">
            <h1 style="font-size:70px;margin-top:-20px;">MCP C2 Provision</h1>
            <h2 style="margin-top:-55px">Start Command and Control Servers via MCP</h2>
             <br><br><br><br>
             <h4> Currently Active MCP plugins</h4>
            <div class="modal-body">
                <center>
                <table class="obfuscation-table ttp-template" border=1 frame=void rules=rows>
                    <tr>
                        <th style="text-align:left;">Plugin</th>
                        <th style="text-align:left;">Interface</th>
                        <th style="text-align:left;">Ports</th>
                        <th style="text-align:left;">Environment</th>
                        <th style="text-align:left;">OS</th>
                        <th style="text-align:left;">State</th>
                        <th style="text-align:left;">DesiredState</th>
                        <th style="text-align:left;">ServiceID</th>
                        <th style="text-align:left;">id</th>
                        <th style="text-align:left;">control</th>
                    </tr>
                    {% for p in plugins %}
                    {% if p.ServiceName != "" and  p.State == "Active" %}
                    <tr>
                        <td>{{ p.Name }}</td>
                        <td>{{ p.Interface }}</td>
                        <td>{{ p.ExternalPorts }}</td>
                        <td>{{ p.Environment }}</td>
                        <td>{{ p.OS }}</td>
                        <td>{{ p.State }}</td>
                        <td>{{ p.DesiredState }}</td>
                        <td>{{ p.ServiceID }}</td>
                        <td>{{ p.ServiceName }}</td>
                        <td>

                            <span style="cursor: pointer" onclick="pcp_plugin_restart('{{p.ServiceName}}', '{{p.id}}')">↻</span>
                            -
                            <span style="cursor: pointer" onclick="pcp_plugin_stop('{{p.ServiceName}}', '{{p.id}}')"> 	&#9995; </span>

                        </td>
                    </tr>
                    {% endif %}
                    {% endfor %}
                </table>
                </center>
                <br><br><br><br>
                <h4>Spawn a new MCP plugin</h4>
                <center>
                <table style="table-layout: fixed;" class="obfuscation-table ttp-template" border=1 frame=void rules=rows>
                    <tr>
                        <th width="20%"></th>
                        <th width="60%" ></th>
                        <th width="20%">Validation</th>
                    </tr>
                    <tr>
                        <td >Plugin</td>
                        <td>
                            <select id="pcp-plugin-name-input"  onchange="pcp_pluginname_check()" class="form-control plugin-name" >
                                <option value="--">--</option>
                                {% for p in plugins %}
                                {% if p.ServiceName == "" and  p.ServiceID == "" %}
                                <option value="{{p.Name}}" requiredOS="{{p.OS}}">{{p.Name}}</option>
                                {% endif %}
                                {% endfor %}
                            </select>
                        </td>
                        <td id="pcp-plugin-name-help">
                            select a plugin
                        </td>
                    </tr>
                    <tr>
                        <td>Interface:</td>
                        <td>
                            <select id="pcp-plugin-interface-input" onchange="pcp_interface_check()" class="form-control plugin-interface">
                                <option value="--">--</option>
                                {% for i in interfaces %}
                                <option value="{{i.Interface}}">{{i.Interface}} {{i.NodeHostName}} ({{i.OS}})</option>
                                {% endfor %}
                            </select>
                        </td>
                        <td id="pcp-plugin-interface-help">
                            select an interface
                        </td>
                    </tr>
                    <tr>
                        <td>Ports:</td>
                        <td>
                            <input class="form-control plugin-ports" id="plugin-external-ports" onkeyup="pcp_port_check()" onchange="pcp_port_check()"/>
                        </td>
                        <td id="pcp-plugin-port-help">
                            Must be port/proto[,port/proto] ex: 1234/tcp,1111/udp
                        </td>
                    </tr>
                    <tr>
                        <td>Environment:</td>
                        <td>
                            <input id="pcp-plugin-environment-input" class="form-control plugin-env" onkeyup="pcp_environment_check()" onchange="pcp_environment_check()"/>
                        </td>
                        <td id="pcp-plugin-environment-help">
                            &#10003;
                        </td>
                    </tr>
                    <tr>
                        <td><button id="pcp-plugin-create-button" onclick="create_new_plugin_instance()" disabled class="button-notready">create</button></td>
                        <td>&nbsp;</td>
                        <td>&nbsp;</td>
                    </tr>
                </table>
                </center>
              </div>
            </div>
         </div>
    </div>
</div>


<div id="pcp-action-modal" class="modal">
    <form class="modal-content" style="width:90%;">
        <div class="container modal-box">
            <div class="row">
                <span onclick="document.getElementById('pcp-action-modal').style.display='none'" class="close" title="Close Modal">&times;</span>
                <div class="column" style="flex:92%">
                    <p style="font-size:12px;color:white">
                        Confirmation Modal!
                    </p>
                </div>
            </div>
        </div>
    </form>
</div>

<script>

    function pcp_pluginname_check(){

        let plugin_selector = $("#pcp-plugin-name-input");
        let plugin_help = $("#pcp-plugin-name-help");
        let user_plugin = plugin_selector.val();
        console.warn($(plugin_selector[0].selectedOptions[0]).attr("requiredos"));
        if (user_plugin !== "--") {
            plugin_help.text("✓");
        } else {
            plugin_help.text("select a plugin");
        }
        check_if_ready();
    }

    function pcp_interface_check(){
        let interface_selector = $("#pcp-plugin-interface-input");
        let interface_help = $("#pcp-plugin-interface-help");
        let user_interface = interface_selector.val();
        if (user_interface !== "--") {
            interface_help.text("✓");
        } else {
            interface_help.text("select an interface");
        }
        check_if_ready();
    }
    function pcp_port_check(){
        let port_help = $("#pcp-plugin-port-help");
        let user_ports = $("#plugin-external-ports").val();
        let port_rgx2 = /^(([1-8][0-9]|9[0-9]|[1-8][0-9]{2}|9[0-8][0-9]|99[0-9]|[1-8][0-9]{3}|9[0-8][0-9]{2}|99[0-8][0-9]|999[0-9]|[1-5][0-9]{4}|6[0-4][0-9]{3}|65000)\/(tcp|udp),{0,1}){1,10}$/;
        if (!port_rgx2.test(user_ports)){
            port_help.text("Must be port/proto[,port/proto] ex: 1234/tcp,1111/udp");
        } else {
            port_help.text("✓");
        }
        check_if_ready();
    }
    function pcp_environment_check(){
        let environment_input =  $("#pcp-plugin-environment-input");
        let env_rgx = /^([0-9a-zA-Z_]{1,100}=[0-9a-zA-Z_.]{1,100},{0,1}){0,20}$|^$/;
        let env_help = $("#pcp-plugin-environment-help");
        let user_env = environment_input.val();
        if(!env_rgx.test(user_env)){
            env_help.text("Must be Key1=Value1[,Key2=Value2[...]");

        } else {
            env_help.text("✓");
        }
        check_if_ready();
    }
    function create_new_plugin_instance(){
        if (check_if_ready()){
            let plugin_selector = $("#pcp-plugin-name-input");
            let interface_selector = $("#pcp-plugin-interface-input");
            let ports_input = $("#plugin-external-ports");
            let environment_input =  $("#pcp-plugin-environment-input");
            let submit_button = $("#pcp-plugin-create-button");
            let new_plugin_data = {
                "id": "NEW",
                "Name": "Name",
                "State": "",
                "DesiredState": "Activate",
                "OS": "all",
                "Interface": "",
                "Environment":[],
                "ExternalPorts": [],
                "InternalPorts": []
            };
            new_plugin_data["Name"] = plugin_selector.val();
            new_plugin_data["OS"] =$(plugin_selector[0].selectedOptions[0]).attr("requiredos");
            new_plugin_data["Interface"] = interface_selector.val();
            new_plugin_data["ExternalPorts"] = ports_input.val();
            new_plugin_data["Internal"] = ports_input.val();
            new_plugin_data["Environment"] = environment_input.val();
            submit_button.hide();
            stream('Wait a moment while PCP activates this plugin ... ');
            restRequest(
                'POST',
                new_plugin_data,
                callback_create_new_plugin_instance,
                "/plugin/mcpplugins/update"
            );
        }
    }

    function pcp_plugin_stop(plugin_name, plugin_id){
        if (confirm('Are you sure you want to stop '+ plugin_name)) {
            restRequest(
                'GET',
                {},
                callback_create_new_plugin_instance,
                "/plugin/mcpplugins/stop/" + plugin_id
            );
        }
    }
    function pcp_plugin_restart(plugin_name, plugin_id) {
        if (confirm('Are you sure you want to restart ' + plugin_name)) {
            restRequest(
                'GET',
                {},
                callback_create_new_plugin_instance,
                "/plugin/mcpplugins/restart/" + plugin_id
            );
        }
    }
    function callback_create_new_plugin_instance(data){
        console.warn(data);
        stream('Please refresh (close/open) this page to view the update');
    }

    function check_if_ready(){
        let submit_button = $("#pcp-plugin-create-button");
        let env_help = $("#pcp-plugin-environment-help");
        let port_help = $("#pcp-plugin-port-help");
        let interface_help = $("#pcp-plugin-interface-help");
        let plugin_help = $("#pcp-plugin-name-help");
        let is_ready = false;
        if (plugin_help.text() === "✓" &&
            interface_help.text() === "✓" &&
                env_help.text() === "✓" &&
                port_help.text() === "✓"
        ){
            submit_button[0].disabled = false;
            submit_button.removeClass("button-notready");
            submit_button.addClass("button-row");
            is_ready = true;
        } else {
            submit_button[0].disabled = true;
            submit_button.removeClass("button-row");
            submit_button.addClass("button-notready");
        }
        return is_ready;
    }
    $(document).ready(function () {
        stream('MCP Command and Control provisioning plugin');
    });
</script>